#ifndef _CAR_PARAMS_INCLUDED_
#define _CAR_PARAMS_INCLUDED_

#define MAX_CARS_TOTAL 400

#define CPARAMS_FILE "data/cars.dat"

#ifndef MAX_UPGRADES
#define MAX_UPGRADES 7
#endif

// constantni parametry aut
typedef struct {
	int max;        // jak moc lze upgradovat (0 - 5)
	int cena;       // cena 1 upgradu
	double speed;   // kolik prida k rychlosti   
 	double acc;     // kolik k akceleraci         - cislo 0.05 == 5%
	double turning; // kolik k zataceni
	double breakes; // kolik k brzdeni
} st_car_upgrade;



// parametry jednotlyvych modelu auta
// u sebe jsou parametry se stejnymi "jednotkami"
typedef struct {
  // technicke udaje
	char   name[56];
	double max_speed;  // maximalni rychlost smerem vpred
	double max_speedB; // maximalni rychlost smerem vzad (je zaporne cislo)

	double acc;     // akcelerace

	double breakes; // sila brzd (0..1) 1 == nebrzbi, 0 == hned stoji (fuj)
	double hbreak;  // sila rucni brzdy viz. ^
	double hbreaks; // sila rucni brzd pri zataceni ( smyku )
	double autoslow; // automaticke zopomalovani = (0..1> 1 == nezpomaluje

	
	double weight;  // hmotnost auta ( dulzite pri narazech ) (zatin nenarazi)
	
	double tearing; // prilavos k povrchu v zatackach ( = (0..1> - 1 == totalni prilnavost, 0 == totalni klouzavost )
	
	double turning; // rychlost zataceni (meneni uhle otoceni) 

	int    light;

	char   file[50]; // jmeno souboru

	int    razeni;    // pocet radicich stupnu

	int    pohar;  // zda se s autem da jezdit tovarni pohar
	int    poharb; // index sede bitmapy pri poharu

	int    kategorie; // kategorie auta A = 0, B = 1,...
	int    cena;
	int    rt;        // typ trati po ktere jede pocitac 0 - 4
	int    zvuk;      // zvuk motoru

	// pozice kol
	POINT  kola[4]; // 0 - leve horni, 1 - prave horni, 2 - leve dolni, 3 - prave dolni

	// MAX_UPGRADES == 7
	char    vycpavka1[4];
	st_car_upgrade upgrade[MAX_UPGRADES]; // vsechny upgrady

	char   line[6][90];

	BOOL    nahon_predni;
	BOOL    nahon_zadni;

	char    vycpavka[4];

} st_GCar_params;

#define CAT_A 0
#define CAT_B 1
#define CAT_C 2
#define CAT_D 3

const char Cats[10] = "ABCDEFGHI";
/*
 upgrady razene 
   -
 motor
 zataceni
 pneu1
 pneu2
 brzdy
 podvozek
 vybaveni
*/
/*
const st_GCar_params  Cparams[20] = {
	{"Audi TT quattro",     22.3,  -7.6,  0.5,  0.99, 
		0.87, 0.87, 0.997, 1575, 0.2, 4,  2, "AudiTT", 5, 0, -1, CAT_C, 1500000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Hlavn ideou pi vvoji typu TT bylo vytvoit ryz sportovn automobil.",  
		 "Neobvykl design, kterm se vyznauje typ TT a jej vrobce tm beze",
		 "zmn pevzal ze studie z roku 1995, naleznete i v interiru automobilu.",
		 "pikov verze TT quattro s pohonem vech kol m motor o vkonu 165 ",
		 "kW a estistupovou manuln pevodovku. Systm pohonu vech kol ",
		 "vyuv hydraulicky ovldanou a elektronicky zenou spojku."},},


	{"BMW Z3",  		19.4,  -6.8,  0.5,  0.99, 
		0.87, 0.87, 0.997,  1575, 0.2, 4, 2,  "BMW_Z3", 5, 0, -1, CAT_C, 5000000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},


	{"BMW Z3 M-HP",  28.5,  -9,    1.2,  0.99, 
		0.87, 0.87, 0.997,  1575, 0.2, 7, 2, "BMW_Z3M_HP", 5, 0, -1, CAT_A, 5000000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},


	{"Dodge Viper GTS",  	28.5,  -9,    0.9,  0.99, 
		0.87, 0.9,  0.997, 1490, 0.2, 4,  2, "Viper_GTS", 5, 0, -1, CAT_A, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Super sportovn automobil znaky Dodge, kter se v Evrop prodv jako",  
		 "Chrysler, plat za klasick Muscle Car novodobho raen. Dvojsedadlov",
		 "typ s plastovou karoseri, kter se vyrb jako roadster s ochrannm",
		 "obloukem (R/T) nebo jako kup (GTS) pohn motor V10 s objemem 8,0",
		 "litru, jen dosahuje vkonu 331 kW. Ten je nejvtm motorem na svt",
		 "pouitm v osobnm automobilu."},},	  

	  
	{"Chevrolet Corvette coup",    26.6,  -8.8,  0.7,  0.99, 
	   0.87, 0.87, 0.997, 1472, 0.2, 4,  2, "Corvette_Coupe", 5, 1, 0, CAT_B, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Pt generace dvojsedadlovho typu Corvette je velice kvalitn",  
		 "sportovn automobil sv tdy. M stejn jako jej pedchdci",
		 "karoserii vyrobenou z plastu. Jako pohon slou motor V8 Small",
		 "Block s objemem 5.7 litru. Pevodovka je tystupov automatick",
		 "a je umstna u zadn npravy, m zabezpeuje vyven",
		 "rozloen hmotnosti na npravy."},},
	  

	{"Chevrolet Corvette cabrio",    26.6,  -8.8,  0.7,  0.99, 
	   0.87, 0.87, 0.997, 1472, 0.2, 4,  2, "Corvette_Cabrio", 5, 0, 2, CAT_B, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Pt generace dvojsedadlovho typu Corvette je velice kvalitn",  
		 "sportovn automobil sv tdy. M stejn jako jej pedchdci",
		 "karoserii vyrobenou z plastu. Jako pohon slou motor V8 Small",
		 "Block s objemem 5.7 litru. Pevodovka je tystupov automatick",
		 "a je umstna u zadn npravy, m zabezpeuje vyven",
		 "rozloen hmotnosti na npravy."},},


	{"Ferrari F355 Berlinetta",	        27.6,  -9.2,  0.9,  0.99, 
		0.87, 0.87, 0.997, 1350, 0.2, 4,  2, "Ferrari_355B", 5, 1, 4, CAT_B, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Okolo dvou tetin produkce znaky Ferrari pipad na adu F355,",  
		 "tvoenou kupm Berlinetta a kabrioletem Spider. Vysokootkov",
		 "motor V8 o objemu 3,5 litru s ptiventilovou technikou a nej-",
		 "vtm vkonem 280 kW (380 k) pi 8200 otkch za minutu je",
		 "uloen za zadn npravou. To umouje idii zat pocit jzdy",
		 "v zvodnm automobilu."},},


	{"Ferrari F355 Spider",	  27.6,  -9.2,  0.9,  0.99, 
		0.87, 0.87, 0.997, 1350, 0.2, 4,  2, "Ferrari_355S", 5, 0, 6, CAT_B, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Okolo dvou tetin produkce znaky Ferrari pipad na adu F355,",  
		 "tvoenou kupm Berlinetta a kabrioletem Spider. Vysokootkov",
		 "motor V8 o objemu 3,5 litru s ptiventilovou technikou a nej-",
		 "vtm vkonem 280 kW (380 k) pi 8200 otkch za minutu je",
		 "uloen za zadn npravou. To umouje idii zat pocit jzdy",
		 "v zvodnm automobilu."},},


	{"Ferrari 456 GT", 30.2,  -10,   1.0,  0.99, 
		0.87, 0.87, 0.997,  1690, 0.2, 5, 2, "Ferrari_456GT", 5, 0, -1, CAT_A, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"??????",  
		 "?????",
		 "????",
		 "???",
		 "??",
		 "?"},},
	  

	{"Ferrari 550 Maranello", 32.0,  -10,   1.0,  0.99, 
	  0.87, 0.87, 0.997, 1690, 0.2, 4,  2, "Ferrari_550", 5, 0, -1, CAT_A, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Tmto modelem se znaka Ferrari u kup s davnctivalcovm motorem",  
		 "opt vrtila ke koncepci s vpedu uloenm motorem. Maranello je ",
		 "postaveno na technickm a konstruknm zkladu typu 456. M stejn",
		 "motor V12 a estistupovou pevodovku. Motor o objemu 5,5 litru",
		 "dosahuje zsluhou vyho kompresnho pomru a modifikovanho sacho",
		 "systmu vkonu 356 kW (485 k)."},},	  


	{"Ferrari F50", 	33.0,  -10,   1.0,  0.99, 
		0.87, 0.87, 0.997,  1350, 0.2, 4, 2, "Ferrari_F50", 5, 0, -1, CAT_A, 5000000, 1, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"??????",  
		 "?????",
		 "????",
		 "???",
		 "??",
		 "?"},},


	{"Ford Focus",     	  17.1,  -6.0,  0.35, 0.99, 
		0.87, 0.87, 0.997,  1575, 0.2, 4, 2, "Ford_Focus", 5, 0, -1, CAT_C, 1500000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},
				

	{"Jaguar XKR coup",	           23.4,  -7.8,  0.6,  0.99, 
		0.87, 0.9,  0.997, 1825, 0.2, 4,  2, "Jaguar_XKR_coupe", 5, 1, 8, CAT_C, 5000000, 2, 0, 
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Oproti svmu pedchdci byla karoserie novho XKR jen mrn upravena.",  
		 "Pod n se ale skrv motor z typu XJR. Jeho nejvt vkon 267 kW",
		 "(363 k) zaazuje XKR mezi vkonj automobily, piem kombinace",
		 "vynikajcch jzdnch vkon, klasickho designu a relativn nzk",
		 "ceny zabezpeuje tomuto automobilu ojedinl postaven. Tento pikov",
		 "model m automatickou regulaci tvrdosti odpruen."},},
				

	{"Jaguar XKR cabrio",	  23.4,  -7.8,  0.6,  0.99, 
		0.87, 0.9,  0.997, 1825, 0.2, 4,  2, "Jaguar_XKR_cabrio", 5, 0, 10, CAT_C, 5000000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Oproti svmu pedchdci byla karoserie novho XKR jen mrn upravena.",  
		 "Pod n se ale skrv motor z typu XJR. Jeho nejvt vkon 267 kW",
		 "(363 k) zaazuje XKR mezi vkonj automobily, piem kombinace",
		 "vynikajcch jzdnch vkon, klasickho designu a relativn nzk",
		 "ceny zabezpeuje tomuto automobilu ojedinl postaven. Tento pikov",
		 "model m automatickou regulaci tvrdosti odpruen."},},
	  

	{"Lamborghini Countach",  30.5,  -9.2,  0.8,  0.99, 
	   0.87, 0.9,  0.997, 1490, 0.2, 4,  2, "Countach", 5, 0, -1, CAT_A, 5000000, 0, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},


	{"Lamborghini Diablo SV",  32.0,  -10,   0.9,  0.99, 
	  	0.87, 0.9,  0.997,  1490, 0.2, 4,  2, "Diablo_SV", 5, 0, -1, CAT_A, 5000000, 0, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"V souasnosti se nabdka italsk automobilky Lamborghini omezuje pouze na",  
		 "model Diablo. Ten s motorem V12 o objemu 5,7 litru ve zvltn sportovn",
		 "verzi SV (Sport Veloce) dosahuje vkonu a 390 kW (530 k). Pepracovan",
		 "brzdov soustava dostala vt kotoue a elisti. Sriov se nyn dodv",
		 "i tolik potebn protiblokovac systm ABS. Maximln rychlost 320 km/h",
		 "zajiuje Diablu pedn msto mezi nejrychlejmi sriovmi automobily."},}, 


	{"Mercedes SLK",     	  20.8,  -7.1,  0.5,  0.99, 
		0.87, 0.87, 0.997,  1575, 0.2, 4,  2,"Mercedes_SLK", 5, 0, -1, CAT_C, 1500000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},	


	{"McLaren F1",    	   33.0,  -10,   1.1,  0.99, 
		0.87, 0.87, 0.997,  1350, 0.2, 4,  2,"Mclaren" , 5, 0, -1, CAT_A, 5000000, 0, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},	


	{"Opel Vectra",     	  17.5,  -6.2,  0.3,  0.99, 
		0.87, 0.87, 0.997,  1575, 0.2, 4,  2,"Opel_vectra", 5, 0, -1, CAT_C, 1500000, 2, 0,
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"skvele auto",  
		 "2. radka",
		 "nic moc",
		 "uz nevim co psat",
		 "to je ale nuda",
		 "posledni radka"},},	


	{"Porshe 911 Turbo",      25.3,  -8.5,  0.7,  0.99, 
		0.87, 0.9,  0.997, 1000, 0.1, 4,  2, "porsche911_Targa", 5, 0, -1, CAT_B, 5000000, 1, 0, 
	{{7, 20}, {33, 20}, {7, 62}, {33, 62},},
	{{5, 80000, 0.05, 0.02, 0, 0}, {5, 50000, 0, 0, 0.05, 0}, {4, 10000, 0.01, 0.01, 0.01, 0},
	{5, 10000, 0.01, 0.01, 0.01} ,{2, 20000, 0, 0, 0, 0.05}, {5, 60000, 0.03, 0.03, 0.03, 0}, 
	{3, 30000, 0.2, 0, 0, 0},},
		{"Porsche 911 Turbo se svm motorem (leat estivlec s protilehlmi vlci)",  
		 "o vkonu 300 kW (408 k), opatenm dvma turbodmychadly, zaujm vrchol ve ",
		 "vrobnm programu stuttgartsk znaky. Mezinpravov diferencil s vizkzn",
		 "spujkou rozdluje podle momentlnch rbrovch podmnek toiv moment",
		 "motoru mezi ob pohnn npravy. Toto Turbo nabz pekvapiv dobr jzdn",
		 "vlastnosti a dky citlivmu penosu hnac sly i dobr vkony."},},
};
*/
#endif
